﻿using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Data;
using System.Collections.ObjectModel;

namespace Post8782
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(62.765625, 71.224140625, 150.65625, 0.911640625);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/App_Data/cntry02.shp"));

                // Draw a feature based on a value  

                ValueStyle valueStyle = new ValueStyle();
                valueStyle.ColumnName = "CNTRY_NAME";
                ValueItem valueItem = new ValueItem();
                valueItem.Value = "China";
                //"Test" is a custom column
                valueItem.CustomStyles.Add(TextStyles.CreateSimpleTextStyle("Test", "Arail Black", 16, DrawingFontStyles.Bold, GeoColor.StandardColors.LightPink));
                valueItem.CustomStyles.Add(new AreaStyle(new GeoSolidBrush(GeoColor.StandardColors.LightGreen)));
                valueStyle.ValueItems.Add(valueItem);
                worldLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(valueStyle);

                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                worldLayer.FeatureSource.CustomColumnFetch += new EventHandler<CustomColumnFetchEventArgs>(FeatureSource_CustomColumnFetch);
                //"Test" is a custom column
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.RequiredColumnNames.Add("Test");
                LayerOverlay staticOverlay = new LayerOverlay();

                staticOverlay.IsBaseOverlay = false;

                staticOverlay.Layers.Add("worldLayer", worldLayer);

                Map1.CustomOverlays.Add(staticOverlay);
            }
        }

        void FeatureSource_CustomColumnFetch(object sender, CustomColumnFetchEventArgs e)
        {
            if (e.Id == "47")
            {
                ShapeFileFeatureSource featureSource = sender as ShapeFileFeatureSource;
                string cntryName = featureSource.GetDataFromDbf(e.Id, "CNTRY_NAME");
                e.ColumnValue = cntryName + " CountryId:" + e.Id;
            }
        }
    }
}
